// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders, HttpQuery } from '../runtime';
import type {
    EgfaModuleType,
    FreigabeBerechtigungEntityListResponseDTO,
    FreigabenBerechtigungenAnBenutzerDTO,
    PermissionEntityType,
} from '../models';

export interface GetFreigabenBerechtigungenRequest {
    type: PermissionEntityType;
    id: string;
    egfaModul?: EgfaModuleType;
}

export interface SetFreigabenBerechtigungenRequest {
    type: PermissionEntityType;
    id: string;
    freigabenBerechtigungenAnBenutzerDTO: FreigabenBerechtigungenAnBenutzerDTO;
    egfaModul?: EgfaModuleType;
}

/**
 * no description
 */
export class FreigabeBerechtigungControllerApi extends BaseAPI {

    /**
     * Lädt alle Berechtigungen für ein Objekt
     * Lädt die Liste der Berechtigungen für das Objekt
     */
    getFreigabenBerechtigungen({ type, id, egfaModul }: GetFreigabenBerechtigungenRequest): Observable<FreigabeBerechtigungEntityListResponseDTO>
    getFreigabenBerechtigungen({ type, id, egfaModul }: GetFreigabenBerechtigungenRequest, opts?: OperationOpts): Observable<AjaxResponse<FreigabeBerechtigungEntityListResponseDTO>>
    getFreigabenBerechtigungen({ type, id, egfaModul }: GetFreigabenBerechtigungenRequest, opts?: OperationOpts): Observable<FreigabeBerechtigungEntityListResponseDTO | AjaxResponse<FreigabeBerechtigungEntityListResponseDTO>> {
        throwIfNullOrUndefined(type, 'type', 'getFreigabenBerechtigungen');
        throwIfNullOrUndefined(id, 'id', 'getFreigabenBerechtigungen');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (egfaModul != null) { query['egfaModul'] = egfaModul; }

        return this.request<FreigabeBerechtigungEntityListResponseDTO>({
            url: '/freigabe-berechtigung/{type}/{id}/berechtigungen'.replace('{type}', encodeURI(type)).replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Ändert die Berechtigungen für ein Objekt
     * Ändert die Berechtigungen für das Objekt
     */
    setFreigabenBerechtigungen({ type, id, freigabenBerechtigungenAnBenutzerDTO, egfaModul }: SetFreigabenBerechtigungenRequest): Observable<void>
    setFreigabenBerechtigungen({ type, id, freigabenBerechtigungenAnBenutzerDTO, egfaModul }: SetFreigabenBerechtigungenRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    setFreigabenBerechtigungen({ type, id, freigabenBerechtigungenAnBenutzerDTO, egfaModul }: SetFreigabenBerechtigungenRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(type, 'type', 'setFreigabenBerechtigungen');
        throwIfNullOrUndefined(id, 'id', 'setFreigabenBerechtigungen');
        throwIfNullOrUndefined(freigabenBerechtigungenAnBenutzerDTO, 'freigabenBerechtigungenAnBenutzerDTO', 'setFreigabenBerechtigungen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (egfaModul != null) { query['egfaModul'] = egfaModul; }

        return this.request<void>({
            url: '/freigabe-berechtigung/{type}/{id}/berechtigungen'.replace('{type}', encodeURI(type)).replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            query,
            body: freigabenBerechtigungenAnBenutzerDTO,
        }, opts?.responseOpts);
    };

}
